﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Windows.Forms;
using System.Threading;


namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
       
        public Form1()
        {
            InitializeComponent();
        }

        private void OpenPort_Button_Click(object sender, EventArgs e)
        {

            try
            {

                serialPort1.Open();
                bool SerialPortState = serialPort1.IsOpen;


                if (SerialPortState == true)
                {
                    label2.BackColor = Color.GreenYellow;
                    return;
                }
                else
                {
                    label2.BackColor = Color.Red;
                    return;
                }

            }
            catch
            {
                MessageBox.Show("پورت با اشکال مواجه است یا شما 2 با سعی به بازکردن آن نموده اید و یا اصلا وجود ندارد", "خطای کاربر", MessageBoxButtons.OK);
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            serialPort1.Close();
            bool SerialPortState = serialPort1.IsOpen;
            if (SerialPortState == true)
            {
                label2.BackColor = Color.GreenYellow;
                return;
            }

            else
                label2.BackColor = Color.Red;
            {
                timer1.Enabled = false;
                return;
            }


        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                timer1.Enabled = true;
                return;
            }

            else
            {
                MessageBox.Show("لطفا پورت را باز کنید", "خطا", MessageBoxButtons.OK);
                return;
            }

            
            




        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            serialPort1.ReadTimeout = 1;
            serialPort1.WriteTimeout = 20;
            SensorState_Textbox.Text = ".سنسور درخواستی دریافت نکرده است";


            bool SerialPortState = serialPort1.IsOpen;
            if (SerialPortState == true)
            {
                label2.BackColor = Color.GreenYellow;
                return;
            }

            else
            {
                label2.BackColor = Color.Red;
                return;
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            //timer1.Enabled = true;
            //Data_R_TextBox.Text = Convert.ToString(serialPort1.ReadChar());
            bool SerialPortState = serialPort1.IsOpen;
            if (SerialPortState == true)
            {
                Data_R_TextBox.Text = Data_R_TextBox.Text + " " + Convert.ToString(serialPort1.ReadExisting());
                return;

            }
            else
            {
                MessageBox.Show("پورت بسته است", "خطا", MessageBoxButtons.OK);
                return;
            }

            





        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            


      }

        private void button3_Click(object sender, EventArgs e)
        {
            

        }

        

        private void timer1_Tick_1(object sender, EventArgs e)
        {
            byte Sensor_Number;

            switch (comboBox_SensorNum.SelectedItem.ToString())
            {
                case "0":
                    Sensor_Number = 0x00;
                    break;
                case "1":
                    Sensor_Number = 0x01;
                    break;
                case "2":
                    Sensor_Number = 0x02;
                    break;
                case "3":
                    Sensor_Number = 0x03;
                    break;
                case "4":
                    Sensor_Number = 0x04;
                    break;
                case "5":
                    Sensor_Number = 0x05;
                    break;
                case "6":
                    Sensor_Number = 0x06;
                    break;
                case "7":
                    Sensor_Number = 0x07;
                    break;
                case "8":
                    Sensor_Number = 0x08;
                    break;
                case "9":
                    Sensor_Number = 0x09;
                    break;
                case "10":
                    Sensor_Number = 0x0A;
                    break;
                case "11":
                    Sensor_Number = 0x0B;
                    break;
                case "12":
                    Sensor_Number = 0x0C;
                    break;
                case "13":
                    Sensor_Number = 0x0D;
                    break;
                case "14":
                    Sensor_Number = 0x0E;
                    break;
                case "15":
                    Sensor_Number = 0x0F;
                    break;
                default:
                    Sensor_Number = 0x00;
                    break;

            }
 

            
            
            /////////////////////////////          
            
            
            byte[] Sensor1 = new byte[2];
            Sensor1[0] = Sensor_Number;
            Sensor1[1] = 0x54;
            




            if (serialPort1.IsOpen == true)
            {
                try
                {
                    serialPort1.Write(Sensor1, 0, 1);
                    System.Threading.Thread.Sleep(1);
                    serialPort1.Write(Sensor1, 1, 1);
                    System.Threading.Thread.Sleep(70);
                    int b = Convert.ToInt16(serialPort1.ReadByte()) * 256;
                    int c = Convert.ToInt16(serialPort1.ReadByte()) + b;// .net port read byte , asink read byte// tread
                    Data_R_TextBox.Text = c.ToString();
                    SensorState_Textbox.Text = "سنسور در حال ارتباط با سیستم است ...";
                    return;
                    

                }
                catch
                {
                    SensorState_Textbox.Text = "سنسور با اشکال مواجه است یا متصل نیست یا خاموش است";
                    return;///// inja jeloye hang kardane narmafzar ro migire
                }
                

            }

            else
                MessageBox.Show("لطفا ابتدا پورت را بازکنید", "خطا", MessageBoxButtons.OK);

            
            


        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            byte first_value=0x00;
            byte final_value=0x00;
            switch (comboBox_first.SelectedItem.ToString())
            {
                case "0":
                    first_value = 0x00;
                    break;
                case "1":
                    first_value = 0x01;
                    break;
                case "2":
                    first_value = 0x02;
                    break;
                case "3":
                    first_value = 0x03;
                    break;
                case "4":
                    first_value = 0x04;
                    break;
                case "5":
                    first_value = 0x05;
                    break;
                case "6":
                    first_value = 0x06;
                    break;
                case "7":
                    first_value = 0x07;
                    break;
                case "8":
                    first_value = 0x08;
                    break;
                case "9":
                    first_value = 0x09;
                    break;
                case "10":
                    first_value = 0x0A;
                    break;
                case "11":
                    first_value = 0x0B;
                    break;
                case "12":
                    first_value = 0x0C;
                    break;
                case "13":
                    first_value = 0x0D;
                    break;
                case "14":
                    first_value = 0x0E;
                    break;
                case "15":
                    first_value = 0x0F;
                    break;
            }   
           

            //////////////

            switch (comboBox_final.SelectedItem.ToString())
            {
                case "0":
                    final_value = 0x00;
                    break;
                case "1":
                    
                    final_value = 0x01;
                    break;
                case "2":
                    final_value = 0x02;
                    break;
                case "3":
                    final_value = 0x03;
                    break;
                case "4":
                    final_value = 0x04;
                    break;
                case "5":
                    final_value = 0x05;
                    break;
                case "6":
                    final_value = 0x06;
                    break;
                case "7":
                    final_value = 0x07;
                    break;
                case "8":
                    final_value = 0x08;
                    break;
                case "9":
                    final_value = 0x09;
                    break;
                case "10":
                    final_value = 0x0A;
                    break;
                case "11":
                    final_value = 0x0B;
                    break;
                case "12":
                    final_value = 0x0C;
                    break;
                case "13":
                    final_value = 0x0D;
                    break;
                case "14":
                    final_value = 0x0E;
                    break;
                case "15":
                    final_value = 0x0F;
                    break;
            }   

            /////////////////


            byte[] Sensor1 = new byte[8];

            Sensor1[0] = first_value;
            Sensor1[1] = 0xA0;
            Sensor1[2] = first_value;
            Sensor1[3] = 0xAA;
            Sensor1[4] = first_value;
            Sensor1[5] = 0xA5;
            Sensor1[6] = first_value;
            Sensor1[7] = final_value;

            

            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write(Sensor1, 0, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 1, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 2, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 3, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 4, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 5, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 6, 1);
                System.Threading.Thread.Sleep(1);
                serialPort1.Write(Sensor1, 7, 1);
                return; 
            }
            if (serialPort1.IsOpen != true)
            {
                MessageBox.Show("پورت بسته است");
                return;
            }

                
        }

        private void comboBox_first_SelectedIndexChanged(object sender, EventArgs e)
        {
            






        }

        private void comboBox_final_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }

        private void com_lbl_Click(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                serialPort1.PortName = Ports_ComboBox.SelectedItem.ToString();
            }
            catch
            {
                MessageBox.Show("زمانی که پورت باز است شما قادر به تغییر آن نیستید ابتدا پورت باز را ببندید و دوباره سعی کنید");
            }
            

        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            Ports_ComboBox.Items.Clear();
                       
            string[] ports = SerialPort.GetPortNames();
            foreach (string port in ports)
            {
                Ports_ComboBox.Items.Add(port);

            }
            Ports_ComboBox.SelectedIndex = 0;







            
         
        }
    }
}
